module texpzl.shelfmap;

import texpzl.texpzl;
import std.algorithm;
import std.math;


struct ShelfMap {
static:
int doMapping(ref Images img, bool autoroll) {
        img.assigns.sort;
        if (autoroll) {
            foreach (ref image; img.assigns) {
                if (image.orig_width < image.orig_height)
                    image.roll ^= true;
            }
        }

        // 理論最小サイズ取得
        int min_pixels;
        foreach (ref a; img.assigns)
            min_pixels += a.width * a.height;
        auto w = nearPow2(cast(int)ceil(sqrt(cast(real)min_pixels)));
        
        while (!procMapping(img, w, w)) {
            w *= 2;
        }
        return w;
    }

    bool procMapping(ref Images img, int width, int height) {
        int lineheight=0;
        int posx=0, posy=0;

        while (1) {
            int validationcounter=0;
            foreach (ref image; img.assigns) {
                if (image.valid)
                    continue;
                if (image.width > width)
                    return false;
                if (posy+image.height > height)
                    return false;
                if (image.width <= width-posx) {
                    image.x = posx;
                    image.y = posy;
                    image.valid = true;
                    lineheight = max(image.height, lineheight);
                    posx += image.width;
                    validationcounter++;
                }
            }
            if (validationcounter == 0)
                break;
            // newline
            posy += lineheight;
            posx = 0;
            lineheight = 0;
        }

        foreach (ref image; img.assigns) {
            if (!image.valid) {
                foreach (ref image2; img.assigns) {
                    image2.valid = false;
                }
                return false;
            }
        }
        
        return true;
    }
}

